/* Copyright (C) 2009 Registro.br. All rights reserved. 
* 
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions are 
* met:
* 1. Redistribution of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
* 
* THIS SOFTWARE IS PROVIDED BY REGISTRO.BR ``AS IS'' AND ANY EXPRESS OR
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIE OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
* EVENT SHALL REGISTRO.BR BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
* OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
* TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
* DAMAGE.
 */
package br.registro.dnsshim.common.server;

import java.io.IOException;

public abstract class AbstractDecoderOutput {
	private AbstractProtocolEncoder encoder;
	private IoFilterChain filterChain;

	public AbstractProtocolEncoder getEncoder() {
		return encoder;
	}

	public void setEncoder(AbstractProtocolEncoder encoder) {
		this.encoder = encoder;
	}

	public IoFilterChain getFilterChain() {
		return filterChain;
	}

	public void setFilterChain(IoFilterChain filterChain) {
		this.filterChain = filterChain;
	}

	public abstract void doOutput(Object message, IoSession session) throws DnsshimProtocolException, IOException;
	
	public void write(Object message, IoSession session) throws DnsshimProtocolException, IOException {
		if (filterChain != null) {
			filterChain.filter(message, session);
		}
		doOutput(message, session);
	}

}
